"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfig = exports.getFirstValue = exports.getPackage = void 0;
const pt = __importStar(require("path"));
function getPackage() {
    try {
        return require(pt.join(process.cwd(), 'package.json')) || {};
    }
    catch (e) {
        return {};
    }
}
exports.getPackage = getPackage;
function getFirstValue(...values) {
    return values.filter((v) => typeof v !== 'undefined')[0];
}
exports.getFirstValue = getFirstValue;
function getConfig(argv) {
    const defaults = Object.assign({ compiler: {}, flattener: {}, settings: {}, sandbox: {}, test: {}, require: [] }, getPackage()['specron']);
    const custom = argv || {};
    return {
        name: getFirstValue(custom['name'], defaults['name'], ''),
        description: getFirstValue(custom['description'], defaults['description'], ''),
        compiler: {
            build: getFirstValue(custom['build'], defaults['compiler']['build'], './build'),
            match: getFirstValue(custom['match'], defaults['compiler']['match'], []),
            severities: getFirstValue(custom['severities'], defaults['compiler']['severities'], ['error', 'warning']),
            evmVersion: getFirstValue(custom['evmVersion'], defaults['compiler']['evmVersion'], 'istanbul'),
            clean: getFirstValue(custom['clean'], defaults['compiler']['clean'], true),
        },
        flattener: {
            build: getFirstValue(custom['build'], defaults['flattener']['build'], './build'),
            match: getFirstValue(custom['match'], defaults['flattener']['match'], []),
            severities: getFirstValue(custom['severities'], defaults['flattener']['severities'], ['error', 'warning']),
        },
        settings: {
            optimization: getFirstValue(custom['optimization'], defaults['compiler']['optimization'], 200),
        },
        sandbox: {
            port: getFirstValue(custom['port'], defaults['sandbox']['port'], 8545),
            ttl: getFirstValue(custom['ttl'], defaults['sandbox']['ttl'], 0),
        },
        test: {
            server: custom['server'] !== false && defaults['test']['server'] !== false,
            port: getFirstValue(custom['port'], defaults['test']['port'], 8545),
            match: getFirstValue(custom['match'], defaults['test']['match'], []),
            blockTime: getFirstValue(custom['blockTime'], defaults['test']['blockTime'], null),
        },
        require: getFirstValue(custom['require'], defaults['require'], []),
    };
}
exports.getConfig = getConfig;
//# sourceMappingURL=env.js.map