"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const util = __importStar(require("util"));
const cproc = __importStar(require("child_process"));
const pt = __importStar(require("path"));
const exec = util.promisify(cproc.exec);
ava_1.default('starts sandbox server', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const command = `./bin/specron sandbox --port 8546 --ttl 1000`;
    const { stdout, stderr } = yield exec(command);
    t.true(stdout.indexOf('localhost:8546') !== -1);
    t.true(stderr === '');
}));
ava_1.default('initializes current folder', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const cwd = `./node_modules/.tmp/init-${Date.now()}`;
    const command = `mkdir -p ${cwd}; cd ${cwd}; ../../../bin/specron init --name foo --description bar; echo code: $?`;
    const { stdout, stderr } = yield exec(command);
    t.true(stdout.indexOf('Continue by running the commands below:') !== -1);
    t.true(stdout.indexOf('code: 0') !== -1);
    t.true(stderr === '');
}));
ava_1.default('compiles smart contracts', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const dist = `./node_modules/.tmp/compile-${Date.now()}`;
    const command = `./bin/specron compile --evmVersion byzantium --severities error warning --match ./src/tests/assets/*.sol --build ${dist}; echo code: $?`;
    const { stdout, stderr } = yield exec(command);
    const tokena = require(pt.join(process.cwd(), dist, 'token-a.json'));
    t.is(tokena.Token1.metadata.settings.evmVersion, 'byzantium');
    t.is(Object.keys(tokena).length, 1);
    t.true(stdout.indexOf('contracts') !== -1);
    t.true(stdout.indexOf('code: 0') !== -1);
    t.true(stderr === '');
}));
ava_1.default('flattens smart contracts', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const dist = `./node_modules/.tmp/flatten-${Date.now()}`;
    const command = `./bin/specron flatten --severities error warning --match ./src/tests/assets/*.sol --build ${dist}; echo code: $?`;
    const { stdout, stderr } = yield exec(command);
    t.true(stdout.indexOf('Contracts') !== -1);
    t.true(stdout.indexOf('code: 0') !== -1);
    t.true(stderr === '');
}));
ava_1.default.serial('runs valid tests', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const command = `./bin/specron test --match ./src/tests/assets/valid.hay.ts --require ts-node/register; echo code: $?`;
    const { stdout, stderr } = yield exec(command);
    t.true(stdout.indexOf('code: 0') !== -1);
    t.true(stderr === '');
}));
ava_1.default.serial('runs invalid tests', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const command = `./bin/specron test --match ./src/tests/assets/invalid.hay.ts --require ts-node/register; echo code: $?`;
    const { stdout, stderr } = yield exec(command);
    t.true(stdout.indexOf('src/tests/assets/invalid.hay.ts') !== -1);
    t.true(stdout.indexOf('code: 1') !== -1);
    t.true(stderr === '');
}));
//# sourceMappingURL=index.test.js.map